import "core-js/modules/es6.array.fill";
import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import SwipeableViews from 'react-swipeable-views';
import { autoPlay, virtualize } from 'react-swipeable-views-utils';
import withStyles from '@material-ui/core/styles/withStyles';
import ChevronLeft from '@material-ui/icons/ChevronLeft';
import ChevronRight from '@material-ui/icons/ChevronRight';
import IconButton from '@material-ui/core/IconButton';
import { fade } from '@material-ui/core/styles/colorManipulator';
import classnames from 'classnames';
import { inject, observer } from 'mobx-react';
import AmpCarousel from './amp/AmpCarousel';
var AutoPlaySwipeableViews = autoPlay(SwipeableViews);
var VirtualizeSwipeableViews = virtualize(SwipeableViews);
var AutoPlayVirtualizeSwipeableViews = autoPlay(VirtualizeSwipeableViews);
export var styles = function styles(theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'column',
      position: 'relative',
      '& img': {
        display: 'block'
      }
    },
    swipeWrap: {
      position: 'relative',
      overflow: 'hidden',
      flex: 1,
      '& .react-swipeable-view-container, & > div:first-child': {
        height: '100%'
      }
    },
    arrows: _defineProperty({}, theme.breakpoints.down('xs'), {
      display: 'none'
    }),
    arrow: {
      position: 'absolute',
      top: '50%',
      marginTop: '-24px'
    },
    leftArrow: {
      left: 0
    },
    rightArrow: {
      right: 0
    },
    icon: {
      height: '30px',
      width: '30px'
    },
    dot: {
      backgroundColor: fade(theme.palette.text.primary, 0.25),
      width: 8,
      height: 8,
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: theme.palette.background.paper,
      borderRadius: '50%',
      display: 'inline-block',
      margin: '0 2px',
      // Same duration as SwipeableViews animation
      transitionDuration: '0.35s'
    },
    dotSelected: {
      backgroundColor: theme.palette.text.primary
    },
    dots: {
      position: 'absolute',
      bottom: '5px',
      textAlign: 'center',
      width: '100%'
    },
    indicator: {
      display: 'none'
    }
  };
};
var Carousel = (_dec = withStyles(styles, {
  name: 'RSFCarousel'
}), _dec2 = inject('app'), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Carousel, _Component);

  function Carousel() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Carousel);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Carousel)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {});

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "slideRenderer", function (_ref) {
      var key = _ref.key,
          index = _ref.index;
      var _this$props = _this.props,
          children = _this$props.children,
          slidesToShow = _this$props.slidesToShow;
      var maxIndex = _this.state.maxIndex;
      var slideCount = React.Children.count(children);
      var baseindex = _this.mod(index, maxIndex) * slidesToShow;
      baseindex = baseindex + slidesToShow >= slideCount ? slideCount - slidesToShow : baseindex;
      var slide = [];

      for (var i = 0; i < slidesToShow; i++) {
        slide.push(React.cloneElement(children[baseindex + i], {
          style: {
            width: 100 / slidesToShow + '%',
            display: 'inline-block'
          },
          key: key + '_' + i
        }));
      }

      return React.createElement("div", {
        key: key
      }, slide);
    });

    return _this;
  }

  _createClass(Carousel, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.disposeReaction) {
        this.disposeReaction();
      }
    }
  }, {
    key: "renderDot",
    value: function renderDot(index) {
      var _this$state = this.state,
          selectedIndex = _this$state.selectedIndex,
          maxIndex = _this$state.maxIndex;
      var classes = classnames(this.props.classes.dot, _defineProperty({}, this.props.classes.dotSelected, index === this.mod(selectedIndex, maxIndex)));
      return React.createElement("div", {
        key: index,
        className: classes
      });
    }
  }, {
    key: "mod",
    value: function mod(n, m) {
      var q = n % m;
      return q < 0 ? q + m : q;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          app = _this$props2.app,
          classes = _this$props2.classes,
          className = _this$props2.className,
          arrows = _this$props2.arrows,
          indicators = _this$props2.indicators,
          style = _this$props2.style,
          children = _this$props2.children,
          autoplay = _this$props2.autoplay,
          infinite = _this$props2.infinite,
          slideRenderer = _this$props2.slideRenderer,
          slidesToShow = _this$props2.slidesToShow,
          interval = _this$props2.interval,
          direction = _this$props2.direction,
          inset = _this$props2.inset,
          slideSpacing = _this$props2.slideSpacing,
          swipeableViewsProps = _this$props2.swipeableViewsProps,
          prevButtonProps = _this$props2.prevButtonProps,
          nextButtonProps = _this$props2.nextButtonProps;
      if (app.amp) return React.createElement(AmpCarousel, this.props);
      var selectedIndex = this.state.selectedIndex;
      var slideCount = React.Children.count(children);
      var Tag = infinite ? VirtualizeSwipeableViews : SwipeableViews;
      Tag = autoplay ? AutoPlaySwipeableViews : Tag;
      Tag = infinite && autoplay ? AutoPlayVirtualizeSwipeableViews : Tag;
      return React.createElement("div", {
        className: classnames(className, classes.root),
        style: style
      }, React.createElement("div", {
        className: classes.swipeWrap
      }, !infinite && React.createElement(Tag, _extends({
        index: selectedIndex,
        onChangeIndex: function onChangeIndex(i) {
          return _this2.setState({
            selectedIndex: i
          });
        },
        direction: direction,
        interval: interval,
        slideStyle: {
          padding: "0 ".concat(slideSpacing, "px")
        },
        style: {
          padding: "0 ".concat(inset, "px")
        }
      }, swipeableViewsProps), children), infinite && React.createElement(Tag, _extends({
        index: selectedIndex,
        onChangeIndex: function onChangeIndex(i) {
          return _this2.setState({
            selectedIndex: i
          });
        },
        direction: direction,
        interval: interval,
        slideRenderer: infinite && (slideRenderer || this.slideRenderer),
        slideStyle: {
          padding: "0 ".concat(slideSpacing, "px")
        },
        style: {
          padding: "0 ".concat(inset, "px")
        }
      }, swipeableViewsProps)), arrows && slideCount > slidesToShow && React.createElement("div", {
        className: classes.arrows
      }, (selectedIndex !== 0 || infinite) && React.createElement(IconButton, _extends({
        className: classnames(classes.arrow, classes.leftArrow),
        onClick: function onClick() {
          return _this2.setState({
            selectedIndex: selectedIndex - 1
          });
        }
      }, prevButtonProps), React.createElement(ChevronLeft, {
        classes: {
          root: classes.icon
        }
      })), (selectedIndex !== slideCount - 1 || infinite) && React.createElement(IconButton, _extends({
        className: classnames(classes.arrow, classes.rightArrow),
        onClick: function onClick() {
          return _this2.setState({
            selectedIndex: selectedIndex + 1
          });
        }
      }, nextButtonProps), React.createElement(ChevronRight, {
        classes: {
          root: classes.icon
        }
      }))), indicators && slideCount > slidesToShow && React.createElement("div", {
        className: classes.dots
      }, Array(Math.ceil(slideCount / slidesToShow)).fill(0).map(function (_, index) {
        return _this2.renderDot(index);
      }))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var nextState = {
        selectedIndex: nextProps.selectedIndex != null ? nextProps.selectedIndex : prevState.selectedIndex || 0,
        maxIndex: Math.ceil(React.Children.count(nextProps.children) / nextProps.slidesToShow)
      };

      if (prevState.selectedIndex == null) {
        return nextState;
      } else {
        return null;
      }
    }
  }]);

  return Carousel;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * Display left/right arrows for navigating through slides
   */
  arrows: PropTypes.bool,

  /**
   * Display indicator dots at the bottom of the component
   */
  indicators: PropTypes.bool,

  /*
   * Option to manually set the selected index
   */
  selectedIndex: PropTypes.number,

  /**
   * If false, the auto play behavior is disabled
   */
  autoplay: PropTypes.bool,

  /**
   * This is the auto play direction
   */
  direction: PropTypes.string,

  /**
   * Delay between auto play transitions (in ms)
   */
  interval: PropTypes.number,

  /**
   * If true, scrolling past the last slide will cycle back to the first
   */
  infinite: PropTypes.bool,

  /**
   * If infinite is enabled, this prop can be used to override the slideRenderer
   */
  slideRenderer: PropTypes.func,

  /**
   * If infinite is enabled, the number of slides to show for each index
   */
  slidesToShow: PropTypes.number,

  /**
   * Amount of pixels to pad the slide container
   */
  inset: PropTypes.number,

  /**
   * Amount of pixels of spacing between each slide
   */
  slideSpacing: PropTypes.number,

  /**
   * Additional props to be passed on to the react-swipeable-views component
   */
  swipeableViewsProps: PropTypes.object,

  /**
   * Additional props to be passed on to "previous" IconButton
   */
  prevButtonProps: PropTypes.object,

  /**
   * Additional props to be passed on to "next" IconButton
   */
  nextButtonProps: PropTypes.object
}), _defineProperty(_class2, "defaultProps", {
  arrows: true,
  indicators: false,
  autoplay: false,
  direction: 'incremental',
  interval: 3000,
  infinite: false,
  slideRenderer: null,
  slidesToShow: 1,
  inset: 0,
  slideSpacing: 0,
  swipeableViewsProps: {},
  prevButtonProps: {
    'aria-label': 'prev'
  },
  nextButtonProps: {
    'aria-label': 'next'
  }
}), _temp)) || _class) || _class) || _class);
export { Carousel as default };
//# sourceMappingURL=Carousel.js.map