import "core-js/modules/es6.array.fill";
import "core-js/modules/es7.array.includes";
import "core-js/modules/es6.string.includes";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _objectSpread from "@babel/runtime/helpers/objectSpread";
import "core-js/modules/es6.function.name";
import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Fragment, Component, createRef } from 'react';
import PropTypes from 'prop-types';
import SwipeableViews from 'react-swipeable-views';
import { autoPlay, virtualize } from 'react-swipeable-views-utils';
import withStyles from '@material-ui/core/styles/withStyles';
import ChevronLeft from '@material-ui/icons/ChevronLeft';
import ChevronRight from '@material-ui/icons/ChevronRight';
import IconButton from '@material-ui/core/IconButton';
import Portal from '@material-ui/core/Portal';
import { fade } from '@material-ui/core/styles/colorManipulator';
import classnames from 'classnames';
import ReactImageMagnify from 'react-image-magnify';
import { ReactPinchZoomPan } from 'react-pinch-zoom-pan';
import TabsRow from './TabsRow';
import analytics from './analytics';
import { inject, observer } from 'mobx-react';
import AmpImageSwitcher from './amp/AmpImageSwitcher';
import LoadMask from './LoadMask';
import Image from './Image';
import Video from './Video';
import isEqual from 'lodash/isEqual';
import get from 'lodash/get';
import set from 'lodash/set';
var AutoPlaySwipeableViews = autoPlay(SwipeableViews);
var VirtualizeSwipeableViews = virtualize(SwipeableViews);
var AutoPlayVirtualizeSwipeableViews = autoPlay(VirtualizeSwipeableViews);

function mod(n, m) {
  var q = n % m;
  return q < 0 ? q + m : q;
}

var paletteIconTextColor = '#77726D';
var mediaPropType = PropTypes.shape({
  src: PropTypes.string.isRequired,
  alt: PropTypes.string,
  video: PropTypes.bool
});
export var styles = function styles(theme) {
  var _leftThumbs, _rightThumbs;

  return {
    root: {
      display: 'flex',
      flexDirection: 'column',
      position: 'relative',
      '& img.rsf-imageSwitcherImage': {
        display: 'block'
      }
    },
    swipeWrap: {
      position: 'relative',
      overflow: 'hidden',
      flex: 1,
      '& .react-swipeable-view-container, & > div:first-child': {
        height: '100%'
      }
    },
    imageWrap: {
      height: '100%',
      width: '100%',
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      '& img.rsf-imageSwitcherImage': {
        maxHeight: '100%',
        maxWidth: '100%',
        objectFit: 'contain'
      }
    },
    thumbsTitle: {
      textTransform: 'uppercase'
    },
    productThumb: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0
    },
    bottomThumbs: {
      marginTop: "".concat(theme.margins.container, "px")
    },
    topThumbs: {
      marginBottom: "".concat(theme.margins.container, "px"),
      order: -1
    },
    leftThumbs: (_leftThumbs = {}, _defineProperty(_leftThumbs, theme.breakpoints.down('xs'), {
      marginTop: "".concat(theme.margins.container, "px")
    }), _defineProperty(_leftThumbs, theme.breakpoints.up('sm'), {
      marginRight: "".concat(theme.margins.container, "px"),
      order: -1
    }), _leftThumbs),
    rightThumbs: (_rightThumbs = {}, _defineProperty(_rightThumbs, theme.breakpoints.down('xs'), {
      marginTop: "".concat(theme.margins.container, "px")
    }), _defineProperty(_rightThumbs, theme.breakpoints.up('sm'), {
      marginLeft: "".concat(theme.margins.container, "px")
    }), _rightThumbs),
    sideThumbs: _defineProperty({}, theme.breakpoints.up('sm'), {
      flexDirection: 'row'
    }),
    sideThumbTabs: {
      flexDirection: 'column'
    },
    sideThumbTab: {
      border: '2px solid transparent'
    },
    selectedSideThumbTab: _defineProperty({}, theme.breakpoints.up('sm'), {
      border: "2px solid ".concat(theme.palette.grey[400])
    }),
    thumbnail: {
      paddingBottom: '8px',
      margin: '0 2px',
      boxSizing: 'content-box',
      height: '50px',
      width: '50px'
    },
    sideThumbnail: {
      padding: 3
    },
    activeThumbs: {
      position: 'absolute',
      width: '100%',
      bottom: '20px'
    },
    selected: {
      borderColor: '#D0D0D0'
    },
    arrows: _defineProperty({}, theme.breakpoints.down('xs'), {
      display: 'none'
    }),
    arrow: {
      position: 'absolute',
      top: '50%',
      marginTop: '-24px'
    },
    leftArrow: {
      left: 0
    },
    rightArrow: {
      right: 0
    },
    icon: {
      height: '30px',
      width: '30px'
    },
    dot: {
      backgroundColor: fade(theme.palette.text.primary, 0.25),
      width: 8,
      height: 8,
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: theme.palette.background.paper,
      borderRadius: '50%',
      display: 'inline-block',
      margin: '0 2px',
      // Same duration as SwipeableViews animation
      transitionDuration: '0.35s'
    },
    dotSelected: {
      backgroundColor: theme.palette.text.primary
    },
    dots: {
      position: 'absolute',
      bottom: '5px',
      textAlign: 'center',
      width: '100%'
    },
    viewerToggle: {
      transform: 'scale(0.4)',
      position: 'absolute',
      top: 0,
      right: 0,
      background: fade(theme.palette.text.icon || paletteIconTextColor, 0.4),
      borderRadius: '50%',
      width: '100px',
      height: '100px',
      transitionDuration: '0.5s',
      '-webkit-tap-highlight-color': 'rgba(0, 0, 0, 0)'
    },
    viewerActive: {
      transform: 'scale(0.4) rotateZ(45deg)'
    },
    viewerOverlay: {
      position: 'fixed',
      top: 0,
      left: 0,
      width: '100%',
      height: '100%',
      background: theme.palette.background.paper,
      zIndex: 9999,
      transitionDuration: '0.5s',
      transform: 'translateY(100%)',
      visibility: 'hidden',
      // prevents lightbox from showing near the bottom of screen when browser controls hide on ios
      '& img': {
        margin: 'auto',
        maxHeight: '100%',
        maxWidth: '100%'
      },
      // Hack to fix root div height of pan/zoom/pinch container
      '& > div:first-child': {
        height: '100%'
      }
    },
    viewerOverlayActive: {
      transform: 'translateY(0%)',
      visibility: 'visible'
    },
    tabsRowRoot: {
      boxShadow: 'none'
    },
    tabScroller: _defineProperty({}, theme.breakpoints.down('xs'), {
      padding: "0 ".concat(theme.margins.container, "px")
    }),
    indicator: {
      display: 'none'
    },
    mask: {
      opacity: '0.8'
    },
    playButton: {
      '&:after': {
        color: 'white',
        content: '"►"',
        position: 'absolute',
        left: 'calc(50% - 24px)',
        top: 'calc(50% - 24px)',
        fontSize: '48px'
      }
    },
    playing: {
      '&:after': {
        display: 'none'
      }
    }
  };
};
/**
 * A swipeable image selector suitable for PDPs
 */

var ImageSwitcher = (_dec = withStyles(styles, {
  name: 'RSFImageSwitcher'
}), _dec2 = inject('app'), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component2) {
  _inherits(ImageSwitcher, _Component2);

  function ImageSwitcher() {
    var _getPrototypeOf2;

    var _this3;

    _classCallCheck(this, ImageSwitcher);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this3 = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ImageSwitcher)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this3)), "state", {
      fullSizeImagesLoaded: true,
      viewerActive: false,
      playingVideo: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this3)), "getSelectedIndex", function () {
      var _this3$state = _this3.state,
          selectedIndex = _this3$state.selectedIndex,
          maxIndex = _this3$state.maxIndex;
      return mod(selectedIndex, maxIndex);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this3)), "renderSlide", function (_ref) {
      var style = _ref.style,
          index = _ref.index,
          src = _ref.src,
          alt = _ref.alt,
          video = _ref.video,
          poster = _ref.poster,
          zoomSrc = _ref.zoomSrc,
          zoomWidth = _ref.zoomWidth,
          zoomHeight = _ref.zoomHeight;
      var _this3$props = _this3.props,
          notFoundSrc = _this3$props.notFoundSrc,
          imageProps = _this3$props.imageProps,
          classes = _this3$props.classes,
          magnifyProps = _this3$props.magnifyProps;

      var imageOnLoad = function imageOnLoad(idx) {
        return idx === 0 ? _this3.onFullSizeImagesLoaded : function () {};
      };

      return React.createElement("div", {
        key: index,
        style: style,
        className: classes.imageWrap
      }, video ? React.createElement(Video, {
        src: src,
        alt: alt,
        poster: poster
      }) : zoomSrc && zoomWidth && zoomHeight ? React.createElement(ImageMagnify, {
        magnifyProps: magnifyProps,
        imageProps: imageProps,
        src: src,
        alt: alt,
        notFoundSrc: notFoundSrc,
        zoomSrc: zoomSrc,
        zoomWidth: zoomWidth,
        zoomHeight: zoomHeight,
        onLoad: imageOnLoad(index)
      }) : React.createElement(Image, _extends({
        notFoundSrc: notFoundSrc,
        src: src,
        alt: alt,
        onLoad: imageOnLoad(index),
        contain: true
      }, imageProps)));
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this3)), "slideRenderer", function (_ref2) {
      var key = _ref2.key,
          index = _ref2.index;
      var slidesToShow = _this3.props.slidesToShow;
      var _this3$state2 = _this3.state,
          images = _this3$state2.images,
          maxIndex = _this3$state2.maxIndex;
      var slideCount = images.length;
      var baseindex = mod(index, maxIndex) * slidesToShow;
      baseindex = baseindex + slidesToShow >= slideCount ? slideCount - slidesToShow : baseindex;
      var slide = [];

      for (var i = 0; i < slidesToShow; i++) {
        slide.push(_this3.renderSlide(_objectSpread({
          index: i
        }, images[baseindex + i])));
      }

      return React.createElement(Fragment, {
        key: key
      }, slide);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this3)), "onFullSizeImagesLoaded", function () {
      _this3.setState({
        fullSizeImagesLoaded: true
      });

      _this3.props.app.applyState({
        loadingProduct: null
      });
    });

    return _this3;
  }

  _createClass(ImageSwitcher, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.disposeReaction) {
        this.disposeReaction();
      }
    }
  }, {
    key: "renderViewerToggle",
    value: function renderViewerToggle() {
      var _this4 = this;

      return React.createElement("div", {
        onClick: function onClick() {
          return _this4.toggleViewer();
        },
        className: classnames(this.props.classes.viewerToggle, _defineProperty({}, this.props.classes.viewerActive, this.state.viewerActive))
      }, React.createElement("svg", {
        width: "100",
        height: "100",
        viewBox: "0 0 100 100"
      }, React.createElement("line", {
        x1: "50",
        y1: "25",
        x2: "50",
        y2: "75",
        strokeWidth: "4",
        stroke: "white"
      }), React.createElement("line", {
        x1: "25",
        y1: "50",
        x2: "75",
        y2: "50",
        strokeWidth: "4",
        stroke: "white"
      })));
    }
  }, {
    key: "toggleViewer",
    value: function toggleViewer() {
      if (this.state.viewerActive) {
        document.body.classList.remove('moov-modal');
      } else {
        document.body.classList.add('moov-modal');
      }

      this.setState({
        viewerActive: !this.state.viewerActive
      });
    }
  }, {
    key: "renderDot",
    value: function renderDot(index) {
      var classes = classnames(this.props.classes.dot, _defineProperty({}, this.props.classes.dotSelected, index === this.getSelectedIndex()));
      return React.createElement("div", {
        key: index,
        className: classes
      });
    }
  }, {
    key: "renderThumbnails",
    value: function renderThumbnails() {
      var _classnames3,
          _this5 = this;

      var _this$props2 = this.props,
          classes = _this$props2.classes,
          thumbnailsTitle = _this$props2.thumbnailsTitle,
          notFoundSrc = _this$props2.notFoundSrc,
          thumbnailImageProps = _this$props2.thumbnailImageProps,
          thumbnailPosition = _this$props2.thumbnailPosition;
      var thumbnails = this.state.thumbnails;
      var modifiedThumbs = thumbnails && thumbnails.map(function (_ref3) {
        var src = _ref3.src,
            alt = _ref3.alt;
        return {
          imageUrl: src,
          alt: alt
        };
      });
      var viewerActive = this.state.viewerActive;
      var isVertical = ['left', 'right'].includes(thumbnailPosition);
      return thumbnails && thumbnails.length > 0 && React.createElement("div", {
        className: classnames(classes.thumbs, (_classnames3 = {}, _defineProperty(_classnames3, classes.activeThumbs, viewerActive), _defineProperty(_classnames3, classes.leftThumbs, !viewerActive && thumbnailPosition === 'left'), _defineProperty(_classnames3, classes.rightThumbs, !viewerActive && thumbnailPosition === 'right'), _defineProperty(_classnames3, classes.topThumbs, !viewerActive && thumbnailPosition === 'top'), _defineProperty(_classnames3, classes.bottomThumbs, !viewerActive && thumbnailPosition === 'bottom'), _classnames3))
      }, React.createElement("div", {
        className: "field"
      }, React.createElement("label", {
        className: classes.thumbsTitle
      }, thumbnailsTitle)), React.createElement(TabsRow, {
        classes: {
          scroller: classes.tabScroller,
          root: classnames(classes.tabsRowRoot, _defineProperty({}, classes.sideThumbTabs, !viewerActive && isVertical)),
          tab: classnames(_defineProperty({}, classes.sideThumbTab, !viewerActive && isVertical)),
          selectedTab: classnames(_defineProperty({}, classes.selectedSideThumbTab, !viewerActive && isVertical))
        },
        imageProps: _objectSpread({
          className: classnames(classes.thumbnail, _defineProperty({}, classes.sideThumbnail, !viewerActive && isVertical)),
          notFoundSrc: notFoundSrc,
          fill: true
        }, thumbnailImageProps),
        centered: true,
        initialSelectedIdx: this.getSelectedIndex(),
        orientation: !viewerActive && isVertical ? 'vertical' : 'horizontal',
        onTabChange: function onTabChange(e, selectedIndex) {
          return _this5.setState({
            selectedIndex: selectedIndex,
            playingVideo: false
          });
        },
        items: modifiedThumbs
      }));
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      if (prevState && prevState.selectedIndex && prevState.selectedIndex !== this.state.selectedIndex && this.props.product) {
        analytics.fire('imageSwitched', {
          product: this.props.product,
          imageUrl: this.props.images[this.state.selectedIndex]
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this6 = this;

      var _this$props3 = this.props,
          app = _this$props3.app,
          product = _this$props3.product,
          classes = _this$props3.classes,
          className = _this$props3.className,
          arrows = _this$props3.arrows,
          indicators = _this$props3.indicators,
          style = _this$props3.style,
          reactPinchZoomPanOptions = _this$props3.reactPinchZoomPanOptions,
          loadingThumbnailProps = _this$props3.loadingThumbnailProps,
          viewerThumbnailsOnly = _this$props3.viewerThumbnailsOnly,
          inset = _this$props3.inset,
          autoplay = _this$props3.autoplay,
          interval = _this$props3.interval,
          direction = _this$props3.direction,
          infinite = _this$props3.infinite,
          slidesToShow = _this$props3.slidesToShow,
          slideSpacing = _this$props3.slideSpacing,
          swipeableViewsProps = _this$props3.swipeableViewsProps,
          magnifyProps = _this$props3.magnifyProps,
          thumbnailPosition = _this$props3.thumbnailPosition;
      var _this$state2 = this.state,
          fullSizeImagesLoaded = _this$state2.fullSizeImagesLoaded,
          images = _this$state2.images,
          thumbnails = _this$state2.thumbnails;

      if (app.amp) {
        return React.createElement(AmpImageSwitcher, {
          product: product,
          images: images,
          className: className,
          classes: {
            root: classes.root,
            dot: classes.dot,
            dots: classes.dots,
            dotSelected: classes.dotSelected,
            thumbnails: classes.thumbs
          },
          arrows: arrows,
          indicators: indicators,
          thumbnails: viewerThumbnailsOnly ? null : thumbnails,
          thumbnailPosition: thumbnailPosition
        });
      }

      var viewerActive = this.state.viewerActive;
      var selectedImage = images[this.getSelectedIndex()];
      var SelectedImageTag = selectedImage.video ? 'video' : 'img';
      magnifyProps = magnifyProps || {};
      set(magnifyProps, 'imageClassName', classnames(get(magnifyProps, 'imageClassName'), 'rsf-imageSwitcherImage'));
      set(magnifyProps, 'style', _objectSpread({}, get(magnifyProps, 'style', {}), {
        display: 'flex'
      }));
      set(magnifyProps, 'enlargedImageStyle', _objectSpread({}, get(magnifyProps, 'enlargedImageStyle', {}), {
        height: '100%'
      }));
      var Tag = infinite ? VirtualizeSwipeableViews : SwipeableViews;
      Tag = autoplay ? AutoPlaySwipeableViews : Tag;
      Tag = infinite && autoplay ? AutoPlayVirtualizeSwipeableViews : Tag;

      var tagProps = _objectSpread({
        index: this.getSelectedIndex(),
        direction: direction,
        interval: interval,
        onChangeIndex: function onChangeIndex(i) {
          return _this6.setState({
            selectedIndex: i
          });
        },
        slideStyle: {
          padding: "0 ".concat(slideSpacing, "px"),
          overflow: 'hidden'
        },
        style: {
          padding: "0 ".concat(inset, "px")
        }
      }, swipeableViewsProps);

      if (infinite) {
        tagProps.slideRenderer = this.slideRenderer;
      } else {
        tagProps.children = images.map(function (image, i) {
          return _this6.renderSlide(_objectSpread({}, image, {
            index: i
          }));
        });
      }

      var slideCount = images.length;
      return React.createElement("div", {
        className: classnames(className, classes.root, _defineProperty({}, classes.sideThumbs, ['left', 'right'].includes(thumbnailPosition))),
        style: style
      }, React.createElement("div", {
        className: classes.swipeWrap
      }, React.createElement(Tag, tagProps), arrows && slideCount > slidesToShow && React.createElement("div", {
        className: classes.arrows
      }, (this.state.selectedIndex !== 0 || infinite) && React.createElement(IconButton, {
        className: classnames(classes.arrow, classes.leftArrow),
        onClick: function onClick() {
          return _this6.setState({
            selectedIndex: _this6.state.selectedIndex - 1
          });
        }
      }, React.createElement(ChevronLeft, {
        classes: {
          root: classes.icon
        }
      })), (this.state.selectedIndex !== slideCount - 1 || infinite) && React.createElement(IconButton, {
        className: classnames(classes.arrow, classes.rightArrow),
        onClick: function onClick() {
          return _this6.setState({
            selectedIndex: _this6.state.selectedIndex + 1
          });
        }
      }, React.createElement(ChevronRight, {
        classes: {
          root: classes.icon
        }
      }))), indicators && slideCount > slidesToShow && React.createElement("div", {
        className: classes.dots
      }, Array(Math.ceil(slideCount / slidesToShow)).fill(0).map(function (_, index) {
        return _this6.renderDot(index);
      })), product && React.createElement(LoadMask, {
        show: product.loadingImages,
        className: classes.mask
      }), product && app.loadingProduct && app.loadingProduct.thumbnail && !fullSizeImagesLoaded && React.createElement(Image, _extends({
        src: app.loadingProduct.thumbnail,
        className: classes.productThumb
      }, loadingThumbnailProps, {
        fill: true
      })), React.createElement(Portal, null, React.createElement("div", {
        className: classnames(classes.viewerOverlay, _defineProperty({}, classes.viewerOverlayActive, viewerActive))
      }, React.createElement(ReactPinchZoomPan, _extends({}, reactPinchZoomPanOptions, {
        render: function render(obj) {
          var _classnames10;

          return React.createElement("div", {
            style: {
              overflow: 'hidden',
              position: 'relative',
              height: '100%'
            }
          }, React.createElement("div", {
            style: {
              display: 'flex',
              height: '100%'
            },
            className: classnames((_classnames10 = {}, _defineProperty(_classnames10, classes.playButton, selectedImage.video), _defineProperty(_classnames10, classes.playing, _this6.state.playingVideo), _classnames10)),
            onClick: function onClick() {
              if (_this6.selectedVideo) {
                if (_this6.selectedVideo.paused) {
                  _this6.selectedVideo.play();

                  _this6.setState({
                    playingVideo: true
                  });
                } else {
                  _this6.selectedVideo.pause();

                  _this6.setState({
                    playingVideo: false
                  });
                }
              }
            }
          }, selectedImage && React.createElement(SelectedImageTag, {
            ref: function ref(el) {
              if (selectedImage.video) {
                _this6.selectedVideo = el;
              }
            },
            src: selectedImage.zoomSrc || selectedImage.src,
            alt: selectedImage.alt,
            style: {
              width: '100%',
              height: 'auto',
              transform: "scale(".concat(obj.scale, ") translateY(").concat(obj.y, "px) translateX(").concat(obj.x, "px)")
            }
          })));
        }
      })), viewerActive && this.renderViewerToggle(), viewerActive && this.renderThumbnails())), !viewerActive && this.renderViewerToggle()), !viewerActive && !viewerThumbnailsOnly && this.renderThumbnails());
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var images = normalizeImages(nextProps, 'images');
      var nextState = {
        images: images,
        thumbnails: normalizeImages(nextProps, 'thumbnails'),
        selectedIndex: nextProps.selectedIndex != null ? nextProps.selectedIndex : prevState.selectedIndex || 0,
        maxIndex: Math.ceil(images.length / nextProps.slidesToShow)
      };

      if (!prevState.images || !isEqual(nextState.images, prevState.images)) {
        // new images are loading in, show the loadingProduct.thumbnail
        nextState.fullSizeImagesLoaded = false; // reset the selected index to the first image

        if (!nextProps.selectedIndex) {
          nextState.selectedIndex = 0;
        }

        return nextState;
      } else if (prevState.selectedIndex == null) {
        return nextState;
      } else {
        return null;
      }
    }
  }]);

  return ImageSwitcher;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * If specified, then the image_switched analytics event will be
   * fired when an image is selected and the product's images and thumbnails will
   * automatically be displayed.
   */
  product: PropTypes.object,

  /**
   * An array of (URL or image object) for the full size images
   */
  images: PropTypes.arrayOf(PropTypes.oneOfType([PropTypes.string, mediaPropType])).isRequired,

  /**
   * An array of thumbnails to display below the main image.  You can also
   * specify `false` to hide the thumbnails entirely.
   */
  thumbnails: PropTypes.oneOfType([PropTypes.bool, PropTypes.arrayOf(PropTypes.oneOfType([PropTypes.string, mediaPropType]))]),

  /**
   * Display left/right arrows for navigating through images
   */
  arrows: PropTypes.bool,

  /**
   * Display indicator dots at the bottom of the component
   */
  indicators: PropTypes.bool,

  /**
   * Optional title for thumbnails block
   */
  thumbnailsTitle: PropTypes.string,

  /*
   * Option to show thumbnails only when zoomed view is active
   */
  viewerThumbnailsOnly: PropTypes.bool,

  /**
   * Props to apply to the Image component used to display the product thumbnail while
   * the product data is loading
   */
  loadingThumbnailProps: PropTypes.object,

  /**
   * Props to apply to the thumbnail images
   */
  thumbnailImageProps: PropTypes.object,

  /**
   * Position of thumbnails, relative to the image viewer
   */
  thumbnailPosition: PropTypes.oneOf(['bottom', 'top', 'left', 'right']),

  /**
   * Props to be added to the Image child components.
   */
  imageProps: PropTypes.object,

  /**
   * Props passed to the [`ReactImageMagnify`](https://github.com/ethanselzer/react-image-magnify#usage)
   * element for an image when pan-to-zoom is enabled (via image `zoomWidth` + `zoomHeight` + `zoomSrc`).
   */
  magnifyProps: PropTypes.object,

  /*
   * Option to manually set the selected index
   */
  selectedIndex: PropTypes.number,

  /**
   * The URL of image to load if an image fails to load
   */
  notFoundSrc: PropTypes.string,

  /**
   * Config options for the image viewer
   */
  reactPinchZoomPanOptions: PropTypes.shape({
    onPinchStart: PropTypes.func,
    onPinchStop: PropTypes.func,
    initialScale: PropTypes.number,
    maxScale: PropTypes.number
  }),

  /**
   * Set to true to always revert back to the first image when image URLs
   * are changed.  This behavior is automatically adopted when the `product`
   * prop is specified.
   */
  resetSelectionWhenImagesChange: PropTypes.bool,

  /**
   * If false, the auto play behavior is disabled
   */
  autoplay: PropTypes.bool,

  /**
   * This is the auto play direction
   */
  direction: PropTypes.string,

  /**
   * Delay between auto play transitions (in ms)
   */
  interval: PropTypes.number,

  /**
   * If true, scrolling past the last slide will cycle back to the first
   */
  infinite: PropTypes.bool,

  /**
   * Amount of pixels to pad the slide container
   */
  inset: PropTypes.number,

  /**
   * If infinite is enabled, the number of slides to show for each index
   */
  slidesToShow: PropTypes.number,

  /**
   * Amount of pixels of spacing between each slide
   */
  slideSpacing: PropTypes.number,

  /**
   * Additional props to be passed on to the react-swipeable-views component
   */
  swipeableViewsProps: PropTypes.object
}), _defineProperty(_class2, "defaultProps", {
  images: [],
  thumbnails: [],
  viewerThumbnailsOnly: false,
  arrows: true,
  indicators: false,
  loadingThumbnailProps: {},
  thumbnailPosition: 'bottom',
  imageProps: {},
  reactPinchZoomPanOptions: {
    maxScale: 3
  },
  autoplay: false,
  direction: 'incremental',
  interval: 3000,
  infinite: false,
  slidesToShow: 1,
  inset: 0,
  slideSpacing: 0,
  swipeabeViewsProps: {}
}), _temp)) || _class) || _class) || _class);
export { ImageSwitcher as default };

var ImageMagnify =
/*#__PURE__*/
function (_Component) {
  _inherits(ImageMagnify, _Component);

  function ImageMagnify() {
    var _this;

    _classCallCheck(this, ImageMagnify);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ImageMagnify).call(this));
    _this.state = {
      primaryNotFound: false,
      zoomPrimaryNotFound: false
    };
    _this.ref = createRef();
    return _this;
  }

  _createClass(ImageMagnify, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var img = this.ref.current;

      if (img && img.complete && img.naturalWidth === 0) {
        this.setState({
          primaryNotFound: true
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state = this.state,
          primaryNotFound = _this$state.primaryNotFound,
          zoomPrimaryNotFound = _this$state.zoomPrimaryNotFound;
      var _this$props = this.props,
          src = _this$props.src,
          alt = _this$props.alt,
          zoomSrc = _this$props.zoomSrc,
          zoomWidth = _this$props.zoomWidth,
          zoomHeight = _this$props.zoomHeight,
          onLoad = _this$props.onLoad,
          notFoundSrc = _this$props.notFoundSrc,
          magnifyProps = _this$props.magnifyProps,
          imageProps = _this$props.imageProps;

      if ((primaryNotFound || zoomPrimaryNotFound) && notFoundSrc) {
        // if either is not found, just do a standard Image:
        return React.createElement(Image, _extends({
          notFoundSrc: notFoundSrc,
          src: primaryNotFound ? notFoundSrc : src,
          alt: alt,
          onLoad: onLoad
        }, imageProps));
      }

      src = Image.getOptimizedSrc(src, get(imageProps, 'quality'), get(imageProps, 'optimize'));
      zoomSrc = Image.getOptimizedSrc(zoomSrc, get(imageProps, 'quality'), get(imageProps, 'optimize'));
      return React.createElement(ReactImageMagnify, _extends({
        enlargedImagePosition: "over"
      }, magnifyProps, {
        smallImage: {
          src: src,
          alt: alt,
          isFluidWidth: true,
          onLoad: onLoad,
          onError: function onError() {
            return _this2.setState({
              primaryNotFound: true
            });
          }
        },
        largeImage: {
          src: zoomSrc,
          width: zoomWidth,
          height: zoomHeight,
          onError: function onError() {
            return _this2.setState({
              zoomPrimaryNotFound: true
            });
          }
        }
      }));
    }
  }]);

  return ImageMagnify;
}(Component);
/**
 * Converts an array that can contain strings or MediaTypeModel instances into
 * an array of objects with src, alt, and video
 * @private
 * @param {Object} props
 * @param {String} key "images" or "thumbnails"
 */


function normalizeImages(props, key) {
  var product = props.product;
  var productName = product && product.name;
  var images = props[key];

  if (!images || !images.length) {
    images = product && product[key];
  }

  return !images ? [] : images.map(function (e) {
    if (typeof e === 'string') {
      return {
        src: e,
        alt: productName,
        video: false
      };
    } else {
      return _objectSpread({}, e, {
        alt: e.alt || productName
      });
    }
  });
}
//# sourceMappingURL=ImageSwitcher.js.map